com.io7m.jtensors.core.quaternions

## Class Quaternion4D

- java.lang.Object
- - com.io7m.jtensors.core.quaternions.Quaternion4D

- All Implemented Interfaces:
    Quaternion4DType, QuaternionReadable4DType

      @Generated(value={"Immutables.generator","Quaternion4DType"})
      public final class Quaternion4D
      extends Object
      implements Quaternion4DType

  The type of 4D `double`-typed quaternions.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Quaternion4D.Builder` Builds instances of type `Quaternion4D`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Quaternion4D.Builder` | `builder()` Creates a builder for `Quaternion4D`.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `Quaternion4D` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `x`, `y`, `z`, `w`.
    `static Quaternion4D` | `of(double x, double y, double z, double w)` Construct a new immutable `Quaternion4D` instance.
    `String` | `toString()` Prints the immutable value `Quaternion4D` with attribute values.
    `double` | `w()`
    `double` | `x()`
    `double` | `y()`
    `double` | `z()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### x

          public double x()

      Specified by:
        `x` in interface `Quaternion4DType`
      Specified by:
        `x` in interface `QuaternionReadable4DType`
      Returns:
        The value of the `x` attribute

    - #### y

          public double y()

      Specified by:
        `y` in interface `Quaternion4DType`
      Specified by:
        `y` in interface `QuaternionReadable4DType`
      Returns:
        The value of the `y` attribute

    - #### z

          public double z()

      Specified by:
        `z` in interface `Quaternion4DType`
      Specified by:
        `z` in interface `QuaternionReadable4DType`
      Returns:
        The value of the `z` attribute

    - #### w

          public double w()

      Specified by:
        `w` in interface `Quaternion4DType`
      Specified by:
        `w` in interface `QuaternionReadable4DType`
      Returns:
        The value of the `w` attribute

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `Quaternion4D` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `x`, `y`, `z`, `w`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `Quaternion4D` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static Quaternion4D of(double x,
                                        double y,
                                        double z,
                                        double w)

      Construct a new immutable `Quaternion4D` instance.
      Parameters:
        `x` - The value for the `x` attribute
        `y` - The value for the `y` attribute
        `z` - The value for the `z` attribute
        `w` - The value for the `w` attribute
      Returns:
        An immutable Quaternion4D instance

    - #### builder

          public static Quaternion4D.Builder builder()

      Creates a builder for `Quaternion4D`.
      Returns:
        A new Quaternion4D builder

Copyright © 2017 <code@io7m.com> http://io7m.com